%================Variables=================

%-----------Power--------------------------
%Fraction of load from fuel cell pack i of type e,
%using fuel f in o in t
lFC = optimvar('lFC',...
    nFC,nFCellPacks,nO,nT,nFuels,...
    'Type','continuous',...
    'LowerBound',0,...
    'UpperBound',1);


%Depth of discharge of battery pack i of type e,
%in o in t from providing base load
dodB = optimvar('dodB',...
    nB,nBPacks,nO,nT,...
    'Type','continuous',...
    'LowerBound',0,...
    'UpperBound',1);


%Fraction of load in MCR from diesel engine j
%using fuel f in o in t
lDE = optimvar('lDE',...
    nDE,nO,nT,nFuelsDE,...
    'Type','continuous',...
    'LowerBound',0,...
    'UpperBound',1);

%-----------Power sources switched on-------
%Binary variable, if fuel cell pack i of type e is switched on,
%using fuel f in o in t
fcIofESwitchedOn = optimvar('fcIofESwitchedOn',...
    nFC,nFCellPacks,nO,nT,nFuels,...
    'Type','integer',...
    'LowerBound',0,...
    'UpperBound',1);

%Binary variable, if battery pack i of type e is switched on
%in o in t
bSwitchedOn = optimvar('bSwitchedOn',...
    nB,nBPacks,nO,nT,...
    'Type','integer',...
    'LowerBound',0,...
    'UpperBound',1);

%Binary variable, if diesel engine j is swithced on in o in t,
%using fuel f

deSwitchedOn = optimvar('deSwitchedOn',...
    nDE,nO,nT,nFuelsDE,...
    'Type','integer',...
    'LowerBound',0,...
    'UpperBound',1);

%-----------Power sources bought------------
%Binary variable, if a fuel cell pack i of type e is bought or not
fcBought = optimvar('fcBought',...
    nFC,nFCellPacks,...
    'Type','integer',...
    'LowerBound',0,...
    'UpperBound',1);

%Binary variable, if a battery pack i of type e is bought or not
bBought = optimvar('bBought',...
    nB,nBPacks,...
    'Type','integer',...
    'LowerBound',0,...
    'UpperBound',1);

%Binary variable, if diesel engine j is bought or not
deBought = optimvar('deBought',...
    nDE,...
    'Type','integer',...
    'LowerBound',0,...
    'UpperBound',1);

%Size fuel tanks of type h for fc fuel f in tonnes
sTanks = optimvar('sTanks',...
    nTankTypes,nFuels,...
    'Type','continuous',...
    'LowerBound',0);

%Size of auxiliary system for fuel cell type e used with
%fuel f
fcAux = optimvar('fcAux',...
    nFC,nFuels,...
    'Type','continuous',...
    'LowerBound',0);

%Binary variables, if % loading of fc type e is above thresholds
fcLoadUpper = optimvar('fcLoadUpper',...
    nFC,nFCellPacks,nO,nT,nFuels,...
    'Type','integer',...
    'LowerBound',0,...
    'UpperBound',1);
