%================Capex===========

%Fuel cells
%Types - number installed - 
%rated power - total power - inv.cost - tot inv.cost
nFuelCells = round(sum(sol.fcBought.*fcTable.fcPowerArray(1:nFC,:)./...
    fcTable.fcPower(1:nFC),2),5);
fcInstalledPower = nFuelCells.*fcTable.fcPower(1:nFC,:);
fcNonimalPower = fcTable.fcPower(1:nFC,:);
fcInstalledCosts = fcInstalledPower.*fcNominalPrice;

%Creating table
fcInstalledTable = table(fcTypes,nFuelCells,fcNonimalPower,...
    fcInstalledPower,fcNominalPrice,fcInstalledCosts);

%filename = 'fcInstalled.xlsx';
%Only need to declare filename once if writing to the same worksheet
filename = 'results.xlsx';
filename = [resultsDir sprintf('%s_%s',casenr,filename)];

writetable(fcInstalledTable,filename,'Sheet','fcInstalled');

%Batteries
%Types - n.installed - rated cap - 
%rated power - total cap - total p -inv.costs - tot inv.costs
nBatteries = sum(batteryBought.*bTable.bPowerArray./bTable.bP,2);
bInstalledCapacity = nBatteries.*bKwh;
bInstalledP = nBatteries.*bTable.bP;
bNominalP = bTable.bP;
batteryCost = nBatteries.*bKwh.*bPrice;

%Creating table
bInstalledCostTable = table(bTypes,nBatteries,bKwh,bP,...
    bInstalledCapacity,bInstalledP,bPrice,batteryCost);

% filename = 'bInstalled.xlsx';
% filename = [resultsDir sprintf('%s_%s',casenr,filename)];
writetable(bInstalledCostTable,filename,'Sheet','bInstalled');



%Diesel engines
%Types - n installed - rated p - total p - nominal inv.costs - total inv.cost
deVectorCounter = 1;
enginesByTypes = zeros(length(Ym),1);
for m = 1:length(Ym)
    for n = 1:Ym(m)
        enginesByTypes(m) = ...
            enginesByTypes(m) + sol.deBought(deVectorCounter);
        deVectorCounter = deVectorCounter + 1;
    end
end

deTypes = find(enginesByTypes)';
if (sum(deTypes) <= 0) == 0
for i = 1:length(deTypes)
    engineType = deTypes(i);         %type
    engineArray(i,1) = engineType;
    engineArray(i,2) = enginesByTypes(engineType); %no. installed of type
    engineArray(i,3) = engines(engineType,1);
    engineArray(i,4) = deInvCost;
    engineArray(i,5) = ...
        engineArray(i,2)*...
        engineArray(i,3)*...
        engineArray(i,4);
end
engineTypes = engineArray(:,1);
numberOfTypes = engineArray(:,2);
deNominalPower = engineArray(:,3);
deNominalCost = engineArray(:,4);
deTotalCost = engineArray(:,5);
deInstalledPower = deNominalPower.*numberOfTypes;
else

engineTypes = 0;
numberOfTypes = 0;
deNominalPower = 0;
deNominalCost = 0;
deTotalCost = 0;
deInstalledPower = deNominalPower.*numberOfTypes;

end
deInstalledTable = ...
    table(engineTypes,numberOfTypes,deNominalPower,deInstalledPower,...
    deNominalCost,deTotalCost);
% filename = 'deInstalled.xlsx';
% filename = [resultsDir sprintf('%s_%s',casenr,filename)];
writetable(deInstalledTable,filename,'Sheet','deInstalled');

%Sum de inv.cost
deSumInvestmentCosts = sum(deTotalCost);
deSumInvCostsTable = table(deSumInvestmentCosts);
% filename = 'deSumInvCosts.xlsx';
% filename = [resultsDir sprintf('%s_%s',casenr,filename)];
writetable(deSumInvCostsTable,filename,'Sheet','deInvCost');

%tanks, reformers and power inverter
%Tanks
%type - size of system - nominal cost - total cost
totalTanksCost = sol.sTanks.*tankCost;
tanksTable = table(tankTypes,sol.sTanks,tankCost,totalTanksCost);
% filename = 'fcFuelTanks.xlsx';
% filename = [resultsDir sprintf('%s_%s',casenr,filename)];
writetable(tanksTable,filename,'Sheet','tanks');

%reformers
%size - nominal cost - total cost
reformerCost = sol.fcAux.*Cef;
reformerTable = table(fcTypes,sol.fcAux,Cef,reformerCost);       
%size of reformer system
% filename = 'fcReformerSystem.xlsx';
% filename = [resultsDir sprintf('%s_%s',casenr,filename)];
writetable(reformerTable,filename,'Sheet','reformers');


%power inverter
%size - nominal cost - total cost
%power inverter
powerInverterCost = bInstalledP.*bInverterPrice;
powerInverterCostTable = ...
    table(bInstalledP,bInverterPrice,powerInverterCost);
% filename = 'powerInverterCost.xlsx';
% filename = [resultsDir sprintf('%s_%s',casenr,filename)];
writetable(powerInverterCostTable,filename,'Sheet','pInverters');


%================Opex=====================
%Fuel cells
%----------------Maintenance costs-------
fcTotalMaintCost = fcInstalledPower.*fcAnMaintCost*20;
fcTotalMaintCostTable = ...
    table(fcTypes,nFuelCells,fcPower,...
    fcInstalledPower,fcAnMaintCost,fcTotalMaintCost);
% filename = 'fcMaintenanceCost.xlsx';
% filename = [resultsDir sprintf('%s_%s',casenr,filename)];
writetable(fcTotalMaintCostTable,filename,'Sheet','fcMaintCost');


%----------------Replacement costs-------
hoursInOperation = 8760*20*ones(nFC,1);
fcNumberOfReplacements = ...
    (hoursInOperation.*fcHourlyDegradation)./...
    fcAllowedDegradation;
fcTotalReplCost = ...
    fcNumberOfReplacements.*fcInstalledPower.*fcReplCost;
fcReplacementsTable = ...
    table(fcTypes,fcHourlyDegradation,hoursInOperation,...
    fcAllowedDegradation,fcNumberOfReplacements,...
    fcReplCost,fcTotalReplCost);
% filename = 'fcReplacementCost.xlsx';
% filename = [resultsDir sprintf('%s_%s',casenr,filename)];
writetable(fcReplacementsTable,filename,'Sheet','fcReplCost');

%Batteries
%----------------Replacement costs-------
bInstalledCapacity = nBatteries.*bKwh;
totalAvailThroughput = availThrput.*nBatteries;
nReplacementsFromBasePower = ...
    evaluate(sum(...
    numberOfReplacementsOfEachBatteryStackAndTypeFromBaseLoad,2),sol);

numberOfReplacementsFromLC = ...
    sum(peakShavingEnergyInEachT).*sum(sol.bBought,2)./...
    totalAvailThroughput;

totalLCReplacementCost = ...
    numberOfReplacementsFromLC.*...
    bReplCost.*...
    bInstalledCapacity;

totalBaseReplacementCost = ...
    nReplacementsFromBasePower.*...
    bReplCost.*...
    bInstalledCapacity;

batteryReplacementCostTable = ...
    table(bTypes,totalAvailThroughput,nReplacementsFromBasePower,...
    numberOfReplacementsFromLC,bReplCost,bInstalledCapacity,...
    totalLCReplacementCost,totalBaseReplacementCost);

% filename = 'batReplacementCost.xlsx';
% filename = [resultsDir sprintf('%s_%s',casenr,filename)];
writetable(batteryReplacementCostTable,filename,'Sheet','batRepl');

%----------------Maintenance costs-------
bTotalMaintenanceCost = 20*bAnnualMaintCost.*bInstalledCapacity;
batteryMaintenanceCostTable = ...
    table(bTypes,bInstalledCapacity,...
    bAnnualMaintCost,bTotalMaintenanceCost);
% filename = 'batMaintenanceCost.xlsx';
% filename = [resultsDir sprintf('%s_%s',casenr,filename)];
writetable(batteryMaintenanceCostTable,filename,'Sheet','batMaint');

%Diesel engines
%----------------Maintenance costs-------
deTotalInstalled = sum(sol.deBought.*deP');
deTotalMaintenanceCost = deAnnualMaintCost*deTotalInstalled*20;
deTotalMaintenanceCostTable = ...
    table(deTotalInstalled,deAnnualMaintCost,...
    deTotalMaintenanceCost);
% filename = 'deMaintenanceCost.xlsx'
% filename = [resultsDir sprintf('%s_%s',casenr,filename)];
writetable(deTotalMaintenanceCostTable,filename,'Sheet','deMaint');

%================Voyex================================================================

%--------------Fuel costs---------------------
%Fuel cells - fuel costs
%fuels - cost t1 - consumption t1 - 
...total cost t1- cost t2 - consumption t2 - total cost t2
fcFuelPricesT1 = fuelCosts(:,:,1)';
fcFuelPricesT2 = fuelCosts(:,:,2)';
fcFuelConsumptionT1 = evaluate(...
    fcFuelConsumptionOfFuelsInTimePeriodsInTonnes(:,1),sol);
fcFuelConsumptionT2 = evaluate(...
    fcFuelConsumptionOfFuelsInTimePeriodsInTonnes(:,2),sol);
fcFuelCostsT1 = evaluate(fcFuelCostArray(:,1),sol);
fcFuelCostsT2 = evaluate(fcFuelCostArray(:,2),sol);

fcFuelCostsTable = table(fcFuels,fcFuelPricesT1,...
    fcFuelConsumptionT1,fcFuelCostsT1,...
    fcFuelPricesT2,fcFuelConsumptionT2,fcFuelCostsT2);

% filename = 'fcFuelCosts.xlsx';
% filename = [resultsDir sprintf('%s_%s',casenr,filename)];
writetable(fcFuelCostsTable,filename,'Sheet','fcFuelCost');

%Fuel cells - emission costs
%emission costs by fXw in t1 - emission costs by fXw in t2

fcEmissionCosts = evaluate(fcEmissionsCostArray,sol);
fcEmissionCostsT1 = reshape(fcEmissionCosts(:,1,:),nFuels,nAirEmissions);
fcEmissionCostsT2 = reshape(fcEmissionCosts(:,2,:),nFuels,nAirEmissions);

fcEmissionCostsTable = table(fcEmissionCostsT1, fcEmissionCostsT2);

% filename = 'fcEmissionCosts.xlsx';
% filename = [resultsDir sprintf('%s_%s',casenr,filename)];
writetable(fcEmissionCostsTable,filename,'Sheet','fcEmissions');

%Batteries
%cost t1 - consumption t1 - tot cost t1- 
...cost t2 - consumption t2 - tot cost t2
elPricesT1 = ePrice(1,1,1);
elPricesT2 = ePrice(1,1,2);
elConsumption = evaluate(totalEnergyFromBatteries,sol);
elConsumptionT1 = sum(elConsumption(1,:));
elConsumptionT2 = sum(elConsumption(2,:));
elCostsT1 = evaluate(sum(elCosts(1,:)),sol);
elCostsT2 = evaluate(sum(elCosts(2,:)),sol);

elCostsTable = table(elPricesT1,elConsumptionT1,elCostsT1,...
    elPricesT2,elConsumptionT2,elCostsT2);

% filename = 'elCosts.xlsx';
% filename = [resultsDir sprintf('%s_%s',casenr,filename)];
writetable(elCostsTable,filename,'Sheet','elCosts');

%Diesel engines - fuel costs
%fuels - cost t1 - consumption t1 - 
...tot cost t1 - cost t2 - consumption t2 - tot cost t2
deFuelPricesT1 = deFCost(:,:,1)';
deFuelPricesT2 = deFCost(:,:,2)';
deFuelConsumption = evaluate(...
    deFuelConsumptionInTonnesMat,sol); %nDE,nO,nT,nFuelsDE


deFuelConsumptionSummed = sum(deFuelConsumption,[1 2]);
deFuelConsumptionReshaped = ...
    (reshape(deFuelConsumptionSummed,nFuelsDE,nT))';

deFuelConsumptionT1 = deFuelConsumptionReshaped(:,1);
deFuelConsumptionT2 = deFuelConsumptionReshaped(:,2);

deFuelCostsT1 = deFuelConsumptionT1.*deFuelPricesT1;
deFuelCostsT2 = deFuelConsumptionT2.*deFuelPricesT2;

deFuelCostsTable = table(deFuelTypes,deFuelPricesT1,...
    deFuelConsumptionT1,deFuelCostsT1,...
    deFuelPricesT2,deFuelConsumptionT2,deFuelCostsT2);

% filename = 'deFuelCosts.xlsx';
% filename = [resultsDir sprintf('%s_%s',casenr,filename)];
writetable(deFuelCostsTable,filename,'Sheet','deFuelCosts');

%Diesel engines - emission costs
%emission costs by fXw in t1 - emission costs by fXw in t2


deEmissionCosts = evaluate(deEmissionsCostArray,sol);
deEmissionCostsT1 = ...
    reshape(deEmissionCosts(:,1,:),nFuelsDE,nAirEmissions);
deEmissionCostsT2 = ...
    reshape(deEmissionCosts(:,2,:),nFuelsDE,nAirEmissions);

deEmissionCostsTable = table(deEmissionCostsT1, deEmissionCostsT2);

% filename = 'deEmissionCosts.xlsx';
% filename = [resultsDir sprintf('%s_%s',casenr,filename)];
writetable(deEmissionCostsTable,filename,'Sheet','deEmissions');


%---------------System cost---------------------
systemCost.voyex.basePowerElectricityCost = evaluate(totalElcosts,sol);
systemCost.voyex.fcFuelCosts = evaluate(fcFuelCosts,sol);
systemCost.voyex.deFuelCosts = evaluate(deFuelCosts,sol);
systemCost.voyex.fcEmissionsCosts = evaluate(fcEmissionCost,sol);
systemCost.voyex.deEmissionsCosts = evaluate(deEmissionsCost,sol);
systemCost.voyex.totalVoyex = ...
    systemCost.voyex.basePowerElectricityCost +...
    systemCost.voyex.fcFuelCosts +...
    systemCost.voyex.deFuelCosts +...
    systemCost.voyex.fcEmissionsCosts +...
    systemCost.voyex.deEmissionsCosts;

systemCost.capex.FuelCells = evaluate(fcModulesInvCosts,sol);
systemCost.capex.FCreformer = evaluate(fcAuxInvCosts,sol);
systemCost.capex.FCtanks = evaluate(fcFuelTankCosts,sol);
systemCost.capex.Batteries = evaluate(bModulesInvCosts,sol);
systemCost.capex.PowerInverter = evaluate(bPowerInverterCosts,sol);
systemCost.capex.DieselEngines = evaluate(deInvestmentCosts,sol);
systemCost.capex.totalCapex = ...
    systemCost.capex.FuelCells +...
    systemCost.capex.FCreformer +...
    systemCost.capex.FCtanks +...
    systemCost.capex.Batteries +...
    systemCost.capex.PowerInverter +...
    systemCost.capex.DieselEngines;

systemCost.opex.fcMaintenanceCosts = evaluate(fcMaintenanceCosts,sol);
systemCost.opex.bMaintenanceCosts = evaluate(bMaintenanceCosts,sol);
systemCost.opex.deMaintenanceCosts = evaluate(deMaintenanceCosts,sol);
systemCost.opex.fcReplacementCosts = evaluate(totalFCReplCost,sol);
systemCost.opex.bBaseReplacementCosts = ...
    evaluate(totalBBasePowerReplCost,sol);
systemCost.opex.bLCReplacementCosts = evaluate(totalLCBatReplCost,sol);
systemCost.opex.totalOpex = ... 
    systemCost.opex.fcMaintenanceCosts +...
    systemCost.opex.bMaintenanceCosts +...
    systemCost.opex.deMaintenanceCosts +...
    systemCost.opex.fcReplacementCosts +...
    systemCost.opex.bBaseReplacementCosts +...
    systemCost.opex.bLCReplacementCosts;

systemCost.capex.sumCosts = ...
    systemCost.opex.totalOpex +...
    systemCost.capex.totalCapex +...
    systemCost.voyex.totalVoyex;

systemCost.capex.totalCost = fval;

filename = 'systemCost.xlsx';
filename = [resultsDir sprintf('%s_%s',casenr,filename)];

opexTable = struct2table(systemCost.opex);
opexTable = table(opexTable{:,:}.',... 
    'RowNames',opexTable.Properties.VariableNames)
%filename = 'opex.xlsx';
%filename = [resultsDir sprintf('%s_%s',casenr,filename)];
writetable(opexTable,filename,'WriteRowNames',true,'Sheet','Opex');

voyexTable = struct2table(systemCost.voyex);
voyexTable = table(voyexTable{:,:}.',... 
    'RowNames',voyexTable.Properties.VariableNames)
%filename = 'voyex.xlsx';
%filename = [resultsDir sprintf('%s_%s',casenr,filename)];
writetable(voyexTable,filename,'WriteRowNames',true,'Sheet','Voyex');

capexTable = struct2table(systemCost.capex);
capexTable = table(capexTable{:,:}.',... 
    'RowNames',capexTable.Properties.VariableNames)
%filename = 'capex.xlsx';
%filename = [resultsDir sprintf('%s_%s',casenr,filename)];
writetable(capexTable,filename,'WriteRowNames',true,'Sheet','Capex');


for t = 1:nT
    for o = 1:nO
        pfc1(t,o) = sum(sum(sum(...
            sol.lFC(:,:,o,t,:).*fcPowerReshaped(:,:,o,t,:))));
        pb1(t,o) = 0.95*sum(sum(sum(sol.dodB(:,:,o,t).*...
            bCapacityReshaped(:,:,o,t)/...
            (fractionOfTime(t,o)*Dr))));
        pde1(t,o) = deEfficiency*sum(sum(...
            sol.lDE(:,o,t,:).*dePowerReshaped(:,o,t,:)));
    end
end

powerInOandT = pfc1 + pb1 + pde1;
power3d(:,:,1) = pfc1;
power3d(:,:,2) = pb1;
power3d(:,:,3) = pde1;

figureName = 'PowerDistributionInOperationalStates';
figure1 = figure('Name',figureName);
for t = 1:nT
    subplot(1,nT,t);
    powers = power3d(t,:,:);
    for j = 1:size(powers,3)
        powersReshaped(j,:) = powers(:,:,j);
    end
    bar(powersReshaped','stacked')
    xlabel('Operational state')
    ylabel('Power delivered [kW]')
    title(["Time period " + t])
    legend('Fuel cells','Batteries',...
        'Diesel engines','location','northwest')
end

  filename = [figureName + ".png"];
    filename = [resultsDir sprintf('%s_%s',casenr,filename)];
    saveas(figure1,filename);

    

    
%----------------Plot-------------------- 
dePowerInOpstates = deEfficiency*sol.lDE.*dePowerReshaped;
dePowerInOpstatesByFuels = sum(dePowerInOpstates,1);
for f = 1:nFuelsDE
    dePowerInOpstatesReshaped(f,:,:) = ...
        dePowerInOpstatesByFuels(1,:,:,f);
end
dePowerInOpstatesReshaped
 
figureName = 'dePowerPlot';
figure('Name',figureName);
for t = 1:nT
    subplot(nT,1,t);
    bar3(dePowerInOpstatesReshaped(:,:,t)');
    view(-56,19);
    legend('MDO','ULSF');
    title(["T" + t]);
    xlabel('Fuel');
    ylabel('Operational state')
    zlim([0 max(max(powerDemand))]);
end
    filename = [figureName + ".png"];
    filename = [resultsDir sprintf('%s_%s',casenr,filename)];
    saveas(gcf,filename);


%Base power from fuel cells
%bar3(newmat)
powerFromFC = fc.*fcTable.fcPowerArray(1:nFC,:);
fcPowerRounded = round(powerFromFC,5);
for t = 1:nT
    figureName = ["fcPowerPlot" + "T" + t]
    figure('Name',figureName);
    plotindex = 1;
    for o = 1:nO
        
        subplot(nO/2,2,plotindex,'align');
        fcPowers = sum(fcPowerRounded(:,:,o,t,:),2);
        newmat = reshape(fcPowers,nFC,nFuels);
        
        bar3(newmat)
        view(-63,21);
        title(["T"+ t + "," + "O" + o])
        %set(gca,'YDir','normal') % reverse the y-axis
        xlabel('FC-fuel')
        ylabel('FC-type')
        zlim([0 1.2*max(max(powerDemand))]);
        if plotindex == 2
            legend('H2-compr.','H2-liquid','LNG','location','northeast');
        end
        plotindex = plotindex + 1;
    end
    filename = [figureName + '.png'];
    filename = [resultsDir sprintf('%s_%s',casenr,filename)];
    saveas(gcf,filename);
end
